<html>
<head>
<title>OgreShaderFFPRenderStateBuilder.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_f1fa7196649e3987904dbdb4948bc856.html">Components</a>      </li>
      <li class="navelem"><a class="el" href="dir_1ff0a99c786b1c34b8d04ba7e7285590.html">RTShaderSystem</a>      </li>
      <li class="navelem"><a class="el" href="dir_167378df2bdccc9b313fc91c17987f1d.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShaderFFPRenderStateBuilder.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShaderFFPRenderStateBuilder_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE.</span>
<a name="l00025"></a>00025 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00026"></a>00026 <span class="comment">*/</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifndef _ShaderFFPRenderStateBuilder_</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#define _ShaderFFPRenderStateBuilder_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderPrerequisites_8h.html">OgreShaderPrerequisites.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef RTSHADER_SYSTEM_BUILD_CORE_SHADERS</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreShaderGenerator_8h.html">OgreShaderGenerator.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 <span class="keyword">namespace </span>RTShader {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00050"></a>00050 <span class="keyword">class </span><a class="code" href="OgreShaderPrerequisites_8h.html#a2e7039d2e7e0e3a2feb2008cc7f4be43">_OgreRTSSExport</a> FFPRenderStateBuilder : <span class="keyword">public</span> Singleton&lt;FFPRenderStateBuilder&gt;, <span class="keyword">public</span> <a class="code" href="namespaceOgre.html#a3f7035c5ce4caa67a610946c00e442d0">RTShaderSystemAlloc</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="comment">// Interface.</span>
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00054"></a>00054     FFPRenderStateBuilder   ();
<a name="l00055"></a>00055     ~FFPRenderStateBuilder  ();
<a name="l00056"></a>00056 
<a name="l00072"></a>00072     <span class="keyword">static</span> FFPRenderStateBuilder&amp;           getSingleton    (); 
<a name="l00073"></a>00073 
<a name="l00089"></a>00089     <span class="keyword">static</span> FFPRenderStateBuilder*           getSingletonPtr ();
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00096"></a>00096     <span class="keywordtype">bool</span>        initialize                  ();
<a name="l00097"></a>00097 
<a name="l00101"></a>00101     <span class="keywordtype">void</span>        finalize                    ();
<a name="l00102"></a>00102 
<a name="l00108"></a>00108     <span class="keywordtype">void</span>        buildRenderState            (<a class="code" href="classOgre_1_1RTShader_1_1ShaderGenerator.html#aa644d456e56ff4fe4179bed69bf54304">ShaderGenerator::SGPass</a>* sgPass, TargetRenderState* renderState);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     
<a name="l00111"></a>00111 <span class="comment">// Protected types.</span>
<a name="l00112"></a>00112 <span class="keyword">protected</span>:
<a name="l00113"></a>00113     <span class="keyword">typedef</span> vector&lt;SubRenderStateFactory*&gt;::type                SubRenderStateFactoryList;
<a name="l00114"></a>00114     <span class="keyword">typedef</span> SubRenderStateFactoryList::iterator                 SubRenderStateFactoryIterator;
<a name="l00115"></a>00115     <span class="keyword">typedef</span> SubRenderStateFactoryList::const_iterator           SubRenderStateFactoryConstIterator;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="comment">// Protected methods.</span>
<a name="l00118"></a>00118 <span class="keyword">protected</span>:
<a name="l00119"></a>00119 
<a name="l00123"></a>00123     <span class="keywordtype">void</span>        buildFFPSubRenderState          (<span class="keywordtype">int</span> subRenderStateOrder, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; subRenderStateType, 
<a name="l00124"></a>00124                                                  <a class="code" href="classOgre_1_1RTShader_1_1ShaderGenerator.html#aa644d456e56ff4fe4179bed69bf54304">ShaderGenerator::SGPass</a>* sgPass, TargetRenderState* renderState);
<a name="l00125"></a>00125     
<a name="l00129"></a>00129     <span class="keywordtype">void</span>        resolveColourStageFlags     (<a class="code" href="classOgre_1_1RTShader_1_1ShaderGenerator.html#aa644d456e56ff4fe4179bed69bf54304">ShaderGenerator::SGPass</a>* sgPass, TargetRenderState* renderState);
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="comment">// Attributes.</span>
<a name="l00133"></a>00133 <span class="keyword">protected</span>:
<a name="l00134"></a>00134     SubRenderStateFactoryList   mFFPSubRenderStateFactoyList;       <span class="comment">// All factories needed by the FFP.</span>
<a name="l00135"></a>00135     
<a name="l00136"></a>00136 };
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="preprocessor">#endif</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
